#include<vcg/complex/complex.h>
#include<wrap/io_trimesh/export_off.h>
using namespace vcg;

class MyVertex; class MyEdge; class MyFace;
struct MyUsedTypes : public UsedTypes<Use<MyVertex>   ::AsVertexType,
                                           Use<MyEdge>     ::AsEdgeType,
                                           Use<MyFace>     ::AsFaceType>{};

class MyVertex  : public Vertex< MyUsedTypes, vertex::Coord3f, vertex::Normal3f, vertex::BitFlags  >{};
class MyFace    : public Face<   MyUsedTypes, face::FFAdj,  face::VertexRef, face::BitFlags > {};
class MyEdge    : public Edge<   MyUsedTypes> {};

class MyMesh    : public tri::TriMesh< std::vector<MyVertex>, 
    std::vector<MyFace> , std::vector<MyEdge>  > {};

int main( int /*argc*/, char **/*argv*/ )
{
  MyMesh m;
  
  MyMesh::VertexIterator vi=tri::Allocator<MyMesh>::AddVertices(m,4);
  MyMesh::FaceIterator fi=tri::Allocator<MyMesh>::AddFaces(m,4);
  
  vi->P() = Point3f(-1,  1, -1);++vi;
  vi->P() = Point3f( 1,  1,  1);++vi;
  vi->P() = Point3f(-1, -1,  1);++vi;
  vi->P() = Point3f( 1, -1, -1);
  
  fi->V(0)=&m.vert[0]; fi->V(1)=&m.vert[2]; fi->V(2)=&m.vert[1]; ++fi;
  fi->V(0)=&m.vert[0]; fi->V(1)=&m.vert[1]; fi->V(2)=&m.vert[3]; ++fi;
  fi->V(0)=&m.vert[0]; fi->V(1)=&m.vert[3]; fi->V(2)=&m.vert[2]; ++fi;
  fi->V(0)=&m.vert[1]; fi->V(1)=&m.vert[2]; fi->V(2)=&m.vert[3]; ++fi;
  
  tri::io::ExporterOFF<MyMesh>::Save(m,"out.off");
  
  printf("Input mesh  vn:%i fn:%i\n",m.VN(),m.FN());
  
  return 0;
}
